(herald "IKEv2 Child" (algebra diffie-hellman) (bound 8) (goals-sat)
  (limit 500))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv2_child_nopfs_bidir.lsp")
(comment "Step count limited to 500")
(comment "Strand count bounded at 8")
(comment "Stop when goals satisfied")

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (secret ni nr lst3 algo3 text) (I R name))
  (defstrand init 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (deflistener (hash I R secret "d"))
  (neq (lst3 algo3))
  (non-orig secret)
  (uniq-orig ni)
  (traces
    ((send
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    ((recv (hash I R secret "d")) (send (hash I R secret "d")))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (secret ni nr lst3 algo3 text) (I R name))
  (defstrand init 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (deflistener (hash R I secret "d"))
  (neq (lst3 algo3))
  (non-orig secret)
  (uniq-orig ni)
  (traces
    ((send
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    ((recv (hash R I secret "d")) (send (hash R I secret "d")))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (secret ni nr lst3 algo3 text) (I R name))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (deflistener (hash I R secret "d"))
  (non-orig secret)
  (uniq-orig nr)
  (traces
    ((recv
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    ((recv (hash I R secret "d")) (send (hash I R secret "d")))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (secret ni nr lst3 algo3 text) (I R name))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (deflistener (hash R I secret "d"))
  (non-orig secret)
  (uniq-orig nr)
  (traces
    ((recv
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    ((recv (hash R I secret "d")) (send (hash R I secret "d")))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (neq (lst3 algo3))
  (non-orig secret)
  (uniq-orig ni)
  (goals
    (forall ((iend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "secret" iend secret)
          (non secret))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R))))))
    (forall ((iend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "secret" iend secret)
          (non secret))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 R)
              (p "resp" "I" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R)
              (p "init" "R" i1 I))))))
    (forall ((iend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "secret" iend secret)
          (non secret))
        (exists ((r1 node))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R)
            (p "resp" "I" r1 I))))))
  (traces
    ((send
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (send
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (recv
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))) (send "blab"))
    (uniq-orig ni)
    (neq (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (hash I R secret "e"))
          (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R))
  (non-orig secret)
  (uniq-orig nr)
  (goals
    (forall ((rend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (non secret))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I))))))
    (forall ((rend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (non secret))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 I)
              (p "resp" "I" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I)
              (p "init" "R" i1 R))))))
    (forall ((rend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (non secret))
        (exists ((i1 node))
          (and (p "init" 0 i1) (p "init" "R" i1 R)
            (p "init" "I" i1 I)))))
    (forall ((rend node) (I R name) (ni nr lst3 algo3 secret text))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (non secret))
        (exists ((i1 node))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "ni" i1 ni) (p "init" "nr" i1 nr)
            (p "init" "algo3" i1 algo3) (p "init" "lst3" i1 lst3)
            (p "init" "secret" i1 secret))))))
  (comment
    "Responder point of view; agreement / weak agreement / aliveness goals")
  (traces
    ((recv
       (cat I R (enc lst3 ni (hash I R secret "e"))
         (enc lst3 ni (hash R I secret "e"))))
      (send
        (cat R I (enc algo3 nr (hash I R secret "e"))
          (enc algo3 nr (hash R I secret "e")))))))
