(herald "IKEv2 Sig" (algebra diffie-hellman) (bound 15))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv2_mac2.scm")
(comment "Strand count bounded at 15")

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci ni TSi TSr cr nr lst1 algo1 lst2 algo2 text) (R I name)
    (i expn) (Gr expr))
  (defstrand init 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gr Gr) (i i))
  (non-orig (ltk R I) (ltk I R))
  (uniq-gen i)
  (uniq-orig ci ni)
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr)))))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (cr nr TSi TSr ci ni lst1 algo1 lst2 algo2 text) (R I name)
    (r expn) (Gi expr))
  (defstrand resp 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gi Gi) (r r))
  (absent (r (exp (gen) Gi)))
  (non-orig (ltk R I) (ltk I R))
  (uniq-gen r)
  (uniq-orig cr nr)
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr)))))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (I R name)
    (i expn) (Gr expr))
  (defstrand init 5 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gr Gr) (i i))
  (non-orig (ltk I R) (ltk R I))
  (uniq-gen i)
  (uniq-orig ni ci)
  (goals
    (forall
      ((iend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 4 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R))))))
    (forall
      ((iend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 4 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 R)
              (p "resp" "I" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R)
              (p "init" "R" i1 I))))))
    (forall
      ((iend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 4 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (non (ltk R I)) (non (ltk I R)))
        (exists ((r1 node) (Gi base) (r expn))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R) (p "resp" "I" r1 I)
            (p "resp" "Gi" r1 Gi) (p "resp" "r" r1 r)
            (= (exp Gi r) (exp Gr i))))))
    (forall
      ((iend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 4 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (non (ltk R I)) (non (ltk I R)))
        (exists ((r1 node) (r expn))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R) (p "resp" "I" r1 I)
            (p "resp" "ni" r1 ni) (p "resp" "nr" r1 nr)
            (p "resp" "r" r1 r) (p "resp" "ci" r1 ci)
            (p "resp" "cr" r1 cr) (p "resp" "lst1" r1 lst1)
            (p "resp" "lst2" r1 lst2) (p "resp" "algo1" r1 algo1)
            (p "resp" "TSi" r1 TSi) (p "resp" "TSr" r1 TSr)
            (p "resp" "Gi" r1 (exp (gen) i))
            (p "resp" "algo2" r1 algo2))))))
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (send "blab"))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (I R name)
    (r expn) (Gi expr))
  (defstrand resp 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gi Gi) (r r))
  (absent (r (exp (gen) Gi)))
  (non-orig (ltk I R) (ltk R I))
  (uniq-gen r)
  (uniq-orig nr cr)
  (goals
    (forall
      ((rend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I))))))
    (forall
      ((rend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 I)
              (p "resp" "I" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I)
              (p "init" "R" i1 R))))))
    (forall
      ((rend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (non (ltk R I)) (non (ltk I R)))
        (exists ((i1 node) (Gr base) (i expn))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "Gr" i1 Gr) (p "init" "i" i1 i)
            (= (exp Gi r) (exp Gr i))))))
    (forall
      ((rend node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (non (ltk R I)) (non (ltk I R)))
        (exists ((i1 node) (i expn))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "ni" i1 ni) (p "init" "nr" i1 nr)
            (p "init" "ci" i1 ci) (p "init" "cr" i1 cr)
            (p "init" "algo1" i1 algo1) (p "init" "lst1" i1 lst1)
            (p "init" "algo2" i1 algo2) (p "init" "lst2" i1 lst2)
            (p "init" "TSr" i1 TSr) (p "init" "TSi" i1 TSi)
            (p "init" "Gr" i1 (exp (gen) r)) (p "init" "i" i1 i))))))
  (comment
    "Responder point of view; agreement / weak agreement / aliveness goals")
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr)))))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci cr ni nr TSi TSr lst1 algo1 lst2 algo2 text) (R I name)
    (Gr expr) (i expn))
  (defstrand init 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gr Gr) (i i))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
  (non-orig (ltk R I) (ltk I R))
  (uniq-gen i)
  (uniq-orig ci ni)
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci cr ni nr TSi TSr lst1 algo1 lst2 algo2 text) (R I name)
    (Gi expr) (r expn))
  (defstrand resp 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gi Gi) (r r))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
  (absent (r (exp (gen) Gi)))
  (non-orig (ltk R I) (ltk I R))
  (uniq-gen r)
  (uniq-orig cr nr)
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci ni TSi TSr cr nr lst1 algo1 lst2 algo2 text) (R I name)
    (r i expn))
  (defstrand init 5 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gr r) (i i))
  (defstrand resp 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gi i) (r r))
  (defstrand blab-skey 2 (key (ltk I R)))
  (defstrand blab-skey 2 (key (ltk R I)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
  (precedes ((0 0) (1 0)) ((0 2) (1 2)) ((0 4) (2 0)) ((0 4) (3 0))
    ((1 1) (0 1)) ((1 3) (0 3)))
  (absent (r (exp (gen) i)))
  (ind-zero-in (r (exp (gen) i)))
  (pen-non-orig (ltk R I) (ltk I R))
  (uniq-gen r i)
  (uniq-orig ci ni cr nr (ltk R I) (ltk I R))
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) r) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) I))
            lst2 TSi TSr (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))))
      (send "blab"))
    ((recv (cat I R ci "0" lst1 (exp (gen) i) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) I))
            lst2 TSi TSr (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr)))))
    ((recv "blab") (send (ltk I R))) ((recv "blab") (send (ltk R I)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul r i)) ci cr)))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (R I name)
    (Gr expr) (i expn))
  (defstrand init 5 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gr Gr) (i i))
  (defstrand blab-skey 2 (key (ltk I R)))
  (defstrand blab-skey 2 (key (ltk R I)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
  (precedes ((0 4) (1 0)) ((0 4) (2 0)))
  (pen-non-orig (ltk R I) (ltk I R))
  (uniq-gen i)
  (uniq-orig ci ni (ltk R I) (ltk I R))
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab")) ((recv "blab") (send (ltk I R)))
    ((recv "blab") (send (ltk R I)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))

(defprotocol mac2 diffie-hellman
  (defrole init
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gr expr)
      (i expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni)
    (uniq-gen i))
  (defrole resp
    (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (Gi expr)
      (r expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr)
    (uniq-gen r)
    (absent (r (exp (gen) Gi))))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton mac2
  (vars (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr text) (R I name)
    (Gi expr) (r expn))
  (defstrand resp 4 (ci ci) (cr cr) (ni ni) (nr nr) (lst1 lst1)
    (algo1 algo1) (lst2 lst2) (algo2 algo2) (TSi TSi) (TSr TSr) (R R)
    (I I) (Gi Gi) (r r))
  (defstrand blab-skey 2 (key (ltk I R)))
  (defstrand blab-skey 2 (key (ltk R I)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
  (precedes ((0 3) (1 0)) ((0 3) (2 0)))
  (absent (r (exp (gen) Gi)))
  (pen-non-orig (ltk R I) (ltk I R))
  (uniq-gen r)
  (uniq-orig cr nr (ltk R I) (ltk I R))
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (hash "MAC" (ltk I R) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc I
            (hash "MAC" (ltk R I) ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I))
            lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (hash "MAC" (ltk I R) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
          (enc R
            (hash "MAC" (ltk R I) ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R))
            algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    ((recv "blab") (send (ltk I R))) ((recv "blab") (send (ltk R I)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
